/**
 * @file Footy.cpp
 * @author Shinji Watanabe
 * @brief Footy̑匳ƂȂNXłB
 * @date Dec. 28, 2008
 */

//-----------------------------------------------------------------------------
/**
 * @brief RXgN^łB
 */
CFooty::CFooty( int nID, HINSTANCE hInstance, int nViewMode ) :
	m_nID( nID ),
	m_nViewMode( VIEWMODE_NORMAL ),
	m_nCharSet( CSM_DEFAULT ),
	m_hWndParent( NULL ),
	m_x( 0 ),
	m_y( 0 ),
	m_nWidth( 0 ),
	m_nHeight( 0 )
{
	// hLgVK쐬
	m_cDoc.CreateNew(m_nID);
	
	// r[
	for ( int i = 0; i < 4; i++ )
	{
		m_cView[i].Initialize( &m_cFonts, m_cView, &m_cDoc, &m_cStatus, m_nID, i );
	}
	
	m_hInstance = hInstance;
	m_nViewMode = nViewMode;
}

//-----------------------------------------------------------------------------
/**
 * @brief Footy쐬܂
 */
bool CFooty::Create( HWND hWnd, int x,int y,int nWidth, int nHeight )
{
	// G[`FbN
	if (!hWnd || nWidth < 0 || nHeight < 0)return false;
	m_hWndParent = hWnd;

	// tHg쐬
	HDC hDC = GetDC(hWnd);
	FOOTY2_PRINTF( L"GetDC %d\n", m_nID );
	if (!m_cFonts.CreateAll(hDC))return false;
	if (!m_cFonts.SetRuler(hDC,m_cView[0].GetRulerHeight()))return false;
	ReleaseDC(hWnd,hDC);
	FOOTY2_PRINTF( L"ReleaseDC %d\n", m_nID );
	
	// oϐɃRs[
	m_nWidth = nWidth;
	m_nHeight = nHeight;
	m_x = x;
	m_y = y;
	
	// r[쐬
	for ( int i = 0; i < 4; i++ )
	{
		if (!m_cView[i].CreateFootyView( hWnd, m_hInstance ))
		{
			return false;
		}
	}
	if ( !m_cVSplitter.Create( hWnd, m_hInstance ) ||
		 !m_cHSplitter.Create( hWnd, m_hInstance ) )
	{
		return false;
	}

	// r[[hύX
	ChangeView( m_nViewMode );
	return true;
}

//-----------------------------------------------------------------------------
/**
 * @brief r[[h̕ύX
 */
void CFooty::ChangeView( int nViewMode, bool bRedraw )
{
	m_nViewMode = nViewMode;

	// Xvb^ύX
	m_cVSplitter.OnBaseWindowMove(m_x,m_y,m_nWidth,m_nHeight);
	m_cHSplitter.OnBaseWindowMove(m_x,m_y,m_nWidth,m_nHeight);

	// [hɍ킹ăr[𒲐߂
	switch(nViewMode)
	{
	case VIEWMODE_NORMAL:
		m_cView[0].MoveWin(m_x,m_y,m_nWidth,m_nHeight);
		m_cHSplitter.SetVisible(false);
		m_cVSplitter.SetVisible(false);
		m_cView[0].SetVisible(true);
		m_cView[1].SetVisible(false);
		m_cView[2].SetVisible(false);
		m_cView[3].SetVisible(false);
		break;
	case VIEWMODE_VERTICAL:
		m_cVSplitter.SetViews(m_cView);
		m_cVSplitter.MoveWin(m_x+m_nWidth / 2 - CSplitBase::SPLIT_SIZE / 2,m_y,m_nWidth,m_nHeight);
		m_cVSplitter.SetVisible(true);
		m_cHSplitter.SetVisible(false);
		m_cView[0].SetVisible(true);
		m_cView[1].SetVisible(true);
		m_cView[2].SetVisible(false);
		m_cView[3].SetVisible(false);
		break;
	case VIEWMODE_HORIZONTAL:
		m_cHSplitter.SetViews(m_cView);
		m_cHSplitter.MoveWin(m_x,m_y+m_nHeight / 2 - CSplitBase::SPLIT_SIZE / 2,m_nWidth,m_nHeight);
		m_cHSplitter.SetVisible(true);
		m_cVSplitter.SetVisible(false);
		m_cView[0].SetVisible(true);
		m_cView[1].SetVisible(true);
		m_cView[2].SetVisible(false);
		m_cView[3].SetVisible(false);
		break;
	case VIEWMODE_QUAD:
		m_cHSplitter.SetViews(m_cView,&m_cVSplitter);
		m_cVSplitter.SetViews(m_cView,&m_cHSplitter);
		m_cHSplitter.MoveWin(m_x,m_y+m_nHeight / 2 - CSplitBase::SPLIT_SIZE / 2,m_nWidth,m_nHeight);
		m_cVSplitter.MoveWin(m_x+m_nWidth / 2 - CSplitBase::SPLIT_SIZE / 2,m_y,m_nWidth,m_nHeight);
		m_cHSplitter.SetVisible(true);
		m_cVSplitter.SetVisible(true);
		m_cView[0].SetVisible(true);
		m_cView[1].SetVisible(true);
		m_cView[2].SetVisible(true);
		m_cView[3].SetVisible(true);
		break;
	case VIEWMODE_INVISIBLE:
		m_cHSplitter.SetVisible(false);
		m_cVSplitter.SetVisible(false);
		m_cView[0].SetVisible(false);
		m_cView[1].SetVisible(false);
		m_cView[2].SetVisible(false);
		m_cView[3].SetVisible(false);
		break;
	}

	// tH[JX𓖂Ă(ꂩtH[JXĂƂ̂)
	if ( IsFocused() )
	{
		m_cView[ 0 ].SetFocus();
	}
	
	// ĕ`
	if (bRedraw)
	{
		m_cView[ 0 ].Refresh();
	}
}

/*-------------------------------------------------------------------
CFooty::IsFocused
ꂩ̃r[tH[JXĂ邩鏈
-------------------------------------------------------------------*/
bool CFooty::IsFocused(){
	for (int i=0;i<3;i++){
		if (m_cView[i].IsFocused())return true;
	}
	return false;
}

/*-------------------------------------------------------------------
CFooty::Move
ړ邽߂̊֐łB
-------------------------------------------------------------------*/
bool CFooty::Move(int x,int y,int nWidth,int nHeight){
	if (nWidth < 0 || nHeight < 0)return false;
	
	/*oϐփRs[*/
	m_nWidth = nWidth;
	m_nHeight = nHeight;
	m_x = x;
	m_y = y;
	
	/*Xvbgo[𒲐*/
	m_cVSplitter.OnBaseWindowMove(m_x,m_y,m_nWidth,m_nHeight);
	m_cHSplitter.OnBaseWindowMove(m_x,m_y,m_nWidth,m_nHeight);
	
	/*[hɉăr[ݒ肷*/
	switch(m_nViewMode)
	{
	case VIEWMODE_NORMAL:
		m_cView[0].MoveWin(x,y,nWidth,nHeight);
		break;
	case VIEWMODE_VERTICAL:
		m_cVSplitter.MoveWin(m_cVSplitter.GetX(),y,nWidth,nHeight);
		break;
	case VIEWMODE_HORIZONTAL:
		m_cHSplitter.MoveWin(x,m_cHSplitter.GetY(),nWidth,nHeight);
		break;
	case VIEWMODE_QUAD:
		m_cVSplitter.MoveWin(m_cVSplitter.GetX(),y,nWidth,nHeight);
		m_cHSplitter.MoveWin(x,m_cHSplitter.GetY(),nWidth,nHeight);
		break;
	}
	
	/*SẴr[ŃLbg쐬*/
	for (int i=0;i<4;i++){
		m_cView[i].CaretMove();
	}
	return true;
}

/*-------------------------------------------------------------------
CFooty::Undo
AhDs܂B
-------------------------------------------------------------------*/
bool CFooty::Undo(){
	if (!m_cDoc.Undo())
		return false;
	/*LbgʒuĐݒ*/
	for (int i=0;i<4;i++){
		if (m_cView[i].IsFocused()){
			m_cView[i].AdjustVisibleLine();
			m_cView[i].AdjustVisiblePos();
		}
	}
	m_cView[0].Refresh();
	/*Cxgʒm*/
	m_cDoc.SendTextModified(MODIFIED_CAUSE_UNDO);
	return true;
}

/*-------------------------------------------------------------------
CFooty::Redo
hDs܂
-------------------------------------------------------------------*/
bool CFooty::Redo(){
	if (!m_cDoc.Redo())
		return false;
	/*LbgʒuĐݒ*/
	for (int i=0;i<4;i++)
	{
		if (m_cView[i].IsFocused())
		{
			m_cView[i].AdjustVisibleLine();
			m_cView[i].AdjustVisiblePos();
		}
	}
	/*ĕ`*/
	m_cView[0].Refresh();
	/*Cxgʒm*/
	m_cDoc.SendTextModified(MODIFIED_CAUSE_REDO);
	return true;
}

/*-------------------------------------------------------------------
CFooty::Copy
Rs[s܂B
-------------------------------------------------------------------*/
bool CFooty::Copy()
{
	if (!m_cDoc.ClipCopy(m_cView[0].GetWnd()))
		return false;
	return true;
}

/*-------------------------------------------------------------------
CFooty::Cut
؂菈s܂B
-------------------------------------------------------------------*/
bool CFooty::Cut()
{
	if (!m_cDoc.ClipCopy(m_cView[0].GetWnd()))
		return false;
	m_cDoc.OnBackSpace();
	/*LbgʒuĐݒ*/
	for (int i=0;i<4;i++){
		if (m_cView[i].IsFocused()){
			m_cView[i].AdjustVisibleLine();
			m_cView[i].AdjustVisiblePos();
		}
	}
	/*ĕ`*/
	m_cView[0].Refresh();
	/*Cxgʒm*/
	m_cDoc.SendTextModified(MODIFIED_CAUSE_CUT);
	return true;
}


/*-------------------------------------------------------------------
CFooty::Paste
y[Xgs܂B
-------------------------------------------------------------------*/
bool CFooty::Paste()
{
	if (!m_cDoc.ClipPaste(m_cView[0].GetWnd()))
		return false;
	/*LbgʒuĐݒ*/
	for (int i=0;i<4;i++)
	{
		if (m_cView[i].IsFocused())
		{
			m_cView[i].AdjustVisibleLine();
			m_cView[i].AdjustVisiblePos();
		}
	}
	/*ĕ`*/
	m_cView[0].Refresh();
	/*Cxgʒm*/
	m_cDoc.SendTextModified(MODIFIED_CAUSE_PASTE);
	return true;
}

/*-------------------------------------------------------------------
CFooty::SetSelText
I𕶎Zbg܂B
-------------------------------------------------------------------*/
bool CFooty::SetSelText(const wchar_t *pString)
{
	if (!m_cDoc.InsertString(pString))return false;
	/*LbgʒuĐݒ*/
	for (int i=0;i<4;i++)
	{
		if (m_cView[i].IsFocused())
		{
			m_cView[i].AdjustVisibleLine();
			m_cView[i].AdjustVisiblePos();
		}
	}
	/*ĕ`*/
	m_cView[0].Refresh();
	/*Cxgʒm*/
	m_cDoc.SendTextModified(MODIFIED_CAUSE_SETSELTEXT);
	return true;
}

/*-------------------------------------------------------------------
CFooty::SetText
Zbg܂B
-------------------------------------------------------------------*/
void CFooty::SetText(const wchar_t *pString)
{
	m_cDoc.SetText(pString);
	m_cView[0].Refresh();
}


/*-------------------------------------------------------------------
CFooty::SetLapel
܂Ԃʒuݒ肵܂B
-------------------------------------------------------------------*/
bool CFooty::SetLapel(int nColumns,int nMode,bool bRedraw)
{
	/*Jׂ*/
	if (nColumns < 2)return false;

	/*Zbg*/
	m_cDoc.SetLapel(nColumns,nMode);
	for (int i=0;i<4;i++)
	{
		m_cView[i].SetVisibleCols();
		m_cView[i].SetFirstColumn(0);
	}
	if (bRedraw)m_cView[0].Refresh(true);
	return true;
}

/*-------------------------------------------------------------------
CFooty::SetFontSize
tHg̃TCYݒ肵܂
-------------------------------------------------------------------*/
bool CFooty::SetFontSize(int nPoint,bool bRedraw)
{
	/*|CgTCY`FbN*/
	if (nPoint < 2)return false;
	
	/*Zbg*/
	HDC hDC = GetDC(m_hWndParent);
	m_cFonts.SetFontSize(nPoint,hDC);
	ReleaseDC(m_hWndParent,hDC);
	
	for (int i=0;i<4;i++)
	{
		m_cView[i].SetVisibleCols();
		m_cView[i].SetFirstColumn(0);
	}
	if (bRedraw)m_cView[0].Refresh(true);
	return true;
}

/*-------------------------------------------------------------------
CFooty::SetFontSize
tHg̃TCYݒ肵܂
-------------------------------------------------------------------*/
bool CFooty::SetFontFace(int nType,const wchar_t *pFaceName,bool bRedraw)
{
	/*Zbg*/
	HDC hDC = GetDC(m_hWndParent);
	m_cFonts.SetFontFace(nType,pFaceName,hDC);
	ReleaseDC(m_hWndParent,hDC);
	
	for (int i=0;i<4;i++)
	{
		m_cView[i].SetVisibleCols();
		m_cView[i].SetFirstColumn(0);
	}
	if (bRedraw)m_cView[0].Refresh(true);
	return true;
}


/*[EOF]*/
